> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/scripting-1.md).

# Scripting

Script management

## GET /cmn/scripting/typescript-declarations

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/typescript-declarations":{"get":{"tags":["Scripting"],"operationId":"getTypeScriptDeclarations","parameters":[{"name":"onlyEav","in":"query","description":"Sollen nur EAV-Typen ausgespielt werden?","required":false,"schema":{"type":"boolean","default":false}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"string","format":"binary"}}}}}}}}}
```

## GET /cmn/scripting/script/runs/{runId}

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/script/runs/{runId}":{"get":{"tags":["Scripting"],"operationId":"getRunById","parameters":[{"name":"runId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/common-scripting-ScriptRun"}}}}}}}},"components":{"schemas":{"common-scripting-ScriptRun":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"script":{"$ref":"#/components/schemas/common-scripting-Script"},"identifier":{"type":"string","description":"ID der Session","maxLength":255,"minLength":0},"logLines":{"type":"array","description":"Log des Runs","items":{"$ref":"#/components/schemas/common-task-TaskLogLine"}},"startedAt":{"type":"string","format":"date-time","description":"Startzeitpunkt"},"finishAt":{"type":"string","format":"date-time","description":"Endzeitpunkt"},"successful":{"type":"boolean","default":true,"description":"War der Run erfolgreich?"}},"required":["finishAt","identifier","script","startedAt"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"common-scripting-Script":{"description":"Script","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"moduleName":{"type":"string","description":"Der Modulname dieses Skripts"},"scriptSource":{"type":"string","description":"Das auszuführende Skript","maxLength":2147483647,"minLength":0},"scriptModuleRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}},"required":["moduleName"]},"core-api-ApiObjectReference":{"description":"Related account","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Activ","readOnly":true}},"required":["id"]},"common-task-TaskLogLine":{"description":"Abschluss-Protokoll","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"logTime":{"type":"string","format":"date-time","description":"logTime","readOnly":true},"origin":{"type":"string","description":"log level","enum":["DEBUG","INFO","WARNING","ERROR","CONSOLE","STACKTRACE"],"readOnly":true},"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"}}},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}}}}}
```

## GET /cmn/scripting/script/module/{module}/script-context-description

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/script/module/{module}/script-context-description":{"get":{"tags":["Scripting"],"operationId":"getScriptContextDescription","parameters":[{"name":"module","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-scripting-ScriptDescription"}}}}}}}},"components":{"schemas":{"core-scripting-ScriptDescription":{"description":"Beschreibung zu einem Skript","properties":{"mainInstance":{"$ref":"#/components/schemas/core-scripting-ScriptingInstanceDescription"},"availableTypes":{"type":"array","description":"Beschreibungen der verfügbaren Typen","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeDescription"}},"availableInput":{"type":"array","description":"Verfügbare Eingabedaten","items":{"$ref":"#/components/schemas/core-scripting-ScriptInputDescription"}}}},"core-scripting-ScriptingInstanceDescription":{"description":"Beschreibung einer Instanz, welcher im Scripting verwendet wird","properties":{"name":{"type":"string","description":"Name des Typs"},"description":{"type":"string","description":"Beschreibung des Typs"},"moduleName":{"type":"string","description":"Name des Moduls, wo diese Instanz definiert ist"},"attributes":{"type":"array","description":"Attribute des Typs","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeAttributeDescription"}},"methods":{"type":"array","description":"Methoden des Typs","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeMethodDescription"}},"usageExample":{"type":"string","description":"Beispiel für die Verwendung"},"type":{"type":"string","description":"Art des Scripting-Typs","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]}}},"core-scripting-ScriptingTypeAttributeDescription":{"description":"Beschreibung eines Attributs eines Objekts, welches im Scripting verwendet wird","properties":{"name":{"type":"string","description":"Name des Attributs"},"description":{"type":"string","description":"Beschreibung des Attributs"},"readOnly":{"type":"boolean","default":false,"description":"Ist das Attribut read-only"},"dataType":{"type":"string","description":"Datentyp des Attributs"},"dataTypeName":{"type":"string","description":"Für Datentyp \"object\": Beschreibung des Objekts"}}},"core-scripting-ScriptingTypeMethodDescription":{"description":"Beschreibung einer Methode eines Objekts, welches im Scripting verwendet wird","properties":{"name":{"type":"string","description":"Name der Methode"},"description":{"type":"string","description":"Beschreibung der Methode"},"returnType":{"type":"string","description":"Rückgabetyp der Methode"},"returnTypeName":{"type":"string","description":"Für Datentyp \"object\": Name des Rückgabe-Typs"},"returnDescription":{"type":"string","description":"Beschreibung zum Rückgabe-Wert"},"parameters":{"type":"array","description":"Parameter der Methode","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeMethodParameterDescription"}},"dataType":{"type":"string"},"dataTypeName":{"type":"string"},"type":{"type":"string","description":"Art des Scripting-Typs","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]}}},"core-scripting-ScriptingTypeMethodParameterDescription":{"description":"Beschreibung eines Parameters einer Methode eines Objekts, welches im Scripting verwendet wird","properties":{"name":{"type":"string","description":"Name des Parameters"},"description":{"type":"string","description":"Beschreibung des Parameters"},"nonNull":{"type":"boolean","default":false,"description":"Ist der Parameter als \"non-null\" definiert"},"dataType":{"type":"string","description":"Datentyp des Parameters"},"dataTypeName":{"type":"string","description":"Für Datentyp \"object\": Name des Parameter-Typs"}}},"core-scripting-ScriptingTypeDescription":{"description":"Beschreibungen der verfügbaren Typen","properties":{"name":{"type":"string","description":"Name des Typs"},"description":{"type":"string","description":"Beschreibung des Typs"},"type":{"type":"string","description":"Art des Scripting-Typs","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]}}},"core-scripting-ScriptInputDescription":{"description":"Beschreibung eines Eingabe-Parameters","properties":{"name":{"type":"string","description":"Name des Parameters"},"description":{"type":"string","description":"Beschreibung des Parameters"},"dataType":{"type":"string","description":"Datentyp des Parameters"},"dataTypeName":{"type":"string","description":"Für Datentyp \"object\": Typ des Parameters"}}}}}}
```

## GET /cmn/scripting/script/module

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/script/module":{"get":{"tags":["Scripting"],"operationId":"getModules","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}}}}}}}
```

## GET /cmn/scripting/markdown-documentation

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/markdown-documentation":{"get":{"tags":["Scripting"],"operationId":"getMarkdownDocumentation","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"string","format":"binary"}}}}}}}}}
```

## GET /cmn/scripting/deprecation-log/{id}

> Find an existing Resource by identifier

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/deprecation-log/{id}":{"get":{"tags":["Scripting"],"summary":"Find an existing Resource by identifier","operationId":"getById_116","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/common-scripting-ScriptDeprecationLog"}}}},"404":{"description":"Resource with given ID was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"common-scripting-ScriptDeprecationLog":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"moduleName":{"type":"string","description":"Modul","maxLength":255,"minLength":0},"containerId":{"type":"integer","format":"int64","description":"Container ID"},"deprecatedElement":{"type":"string","description":"Element"},"deprecatedElementType":{"type":"string","description":"Arten von Elementen in Skript-Typen","enum":["TYPE","ATTRIBUTE","METHOD"]},"deprecationMessage":{"type":"string","description":"Meldung","maxLength":2147483647,"minLength":0}},"required":["containerId","deprecatedElement","deprecatedElementType","moduleName"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Zu verwendende Search-Dialogs","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Zu verwendende Search-Dialogs","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Schlüssel für das Ergebnis vom Search-Dialog","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search-Dialog"}}}}
```

## DELETE /cmn/scripting/deprecation-log/{id}

> Delete an existing Resource

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.29.3"},"tags":[{"name":"Scripting","description":"Script management"},{"name":"Scripting","description":"Script deprecation logs"}],"servers":[{"url":"http://10.102.24.74:32794/api","description":"Generated server url"}],"paths":{"/cmn/scripting/deprecation-log/{id}":{"delete":{"tags":["Scripting"],"summary":"Delete an existing Resource","operationId":"delete_98","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}},"404":{"description":"Resource was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}},"409":{"description":"unable to delete Resource, due to constraints, existing references or internal state","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Zu verwendende Search-Dialogs","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Zu verwendende Search-Dialogs","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Schlüssel für das Ergebnis vom Search-Dialog","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search-Dialog"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.vario-software.de/api-reference/scripting-1.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
